import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Politie rijdt rond en beweegt willekeurig
 * 
 * @author (Adriaan van den Berg en Tim Kroek) 
 * @version (9-10-2014)
 */
public class Police extends Actor
{
    private int random = Greenfoot.getRandomNumber(4);
    private int turnInterval = 50;
    private int delayCount = 0;
    private int rotation;
    private int turnDelay = 0;
    private boolean crossroad = false;
    private int speedPolice = 4;

    /**
     * Politie beweegt in een snelhied kleiner dan de Taxi. (4)
     * Politie krijgt een willekeurige rijrichting mee.
     */
    public void act() 
    {
        checkCollision(speedPolice);

        arrestTaxi();

        movePolice(speedPolice, random); 

        delayCount++;
    }  

    public void movePolice(int moveAmt, int random)  
    {  
        // bepaal richting door het random nummer.
        int dx = 0, dy = 0;  
        if (random == 0){
            setRotation(0);
            dx += 1;  }
        if (random == 1) {
            setRotation(180);
            dx -= 1;  }
        if (random == 2){
            setRotation(90);
            dy += 1;  }
        if (random == 3){
            setRotation(270);
            dy -= 1;  }
        // check for wall on each step of move in both vertical and horizontal directions  
        for (int i = 0; i < moveAmt; i++)  
        {  
            setLocation(getX() + dx, getY());  
            if (getOneIntersectingObject(Wall.class) != null || getOneIntersectingObject(Smoke.class) != null) setLocation(getX() - dx, getY());  

            setLocation(getX(), getY() + dy);  
            if (getOneIntersectingObject(Wall.class) != null || getOneIntersectingObject(Smoke.class) != null) setLocation(getX(), getY() - dy); 
        }  
    } 

    /**
     * Methode Check Collision
     * Kijk continue of er in de buurt een muur of rookwolk zit.
     * Sla de muur op in een lijst(Werkt niet As of now)

      
    public void  checkRandomCollision(int random)
    {
    //Maak een List aan die wallsCollided heet om de muren bij te houden. 
    List wallsCollided = new ArrayList();

    wallsCollided = getIntersectingObjects(Wall.class);

    if(wallsCollided++)
    {
    this.random = Greenfoot.getRandomNumber(4);
    }

    }

     */

    /**
     * Methode Check Collision
     * Kijk continue of er in de buurt een muur zit.
     */

    public void checkCollision(int moveAmt)
    {
        //haal random nummer op voor de riching van de Auto.
        setLocation(getX() + 3, getY());  
        if (getOneIntersectingObject(Wall.class) != null){ setLocation(getX() - 5, getY());  
            this.random = Greenfoot.getRandomNumber(4);
        }
        else{setLocation(getX() - 3, getY());  }
        setLocation(getX(), getY() + 3);  
        if (getOneIntersectingObject(Wall.class) != null){ setLocation(getX(), getY() - 5); 
            this.random = Greenfoot.getRandomNumber(4);
        }
        else{setLocation(getX(), getY() - 3); }
        setLocation(getX() - 3, getY());  
        if (getOneIntersectingObject(Wall.class) != null){ setLocation(getX() + 5, getY());  
            this.random = Greenfoot.getRandomNumber(4);
        }
        else{setLocation(getX() + 3, getY());  }
        setLocation(getX(), getY() - 3);  
        if (getOneIntersectingObject(Wall.class) != null){ setLocation(getX(), getY() + 5); 
            this.random = Greenfoot.getRandomNumber(4);
        }
        else{setLocation(getX(), getY() + 3); }
        if (getOneIntersectingObject(Crossroad.class) != null){
            if(delayCount >= turnInterval){
                this.crossroad = true;
                this.delayCount = 0;
            }
        }
        if(crossroad == true){
            this.turnDelay++;
        }
        if(turnDelay==7){
            this.random = Greenfoot.getRandomNumber(4);
            this.turnDelay = 0;
            this.crossroad = false;
        }

        //Als muur een grotere waarde heeft dan null
    }

    public void arrestTaxi()
    {
        Actor criminal = getOneIntersectingObject(Taxi.class);

        //De actor Taxi is de Taxi die je aanraakt.
        if(criminal!=null)
        //Als taxi een grotere waarde heeft dan null
        {
            Greenfoot.playSound("Siren.wav");
            //maak een sirene geluid als je de taxi pakt.
            removeTouching(Taxi.class);
            //Verwijder de taxi van het veld.#
            getWorld().addObject(new gameOver(), 371, 372);
            //als je gepakt wordt door de politie moet er een plaatje komen.
            Greenfoot.stop();
            //het scenario moet stoppen als je wordt gepakt
        }
    }

}

