import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Taxi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Taxi extends Actor
{
    /**
     * Act - do whatever the Taxi wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    //Maak een Counter die counter heet.

    private Counter counter;

    private int smokeReloadTime;            
    private int reloadDelayCount;
    private int passengersInTaxi = 0;

    private int taxiSpeed = 5;
    private int stopTime = 0;


    public Taxi(Counter scoreCounter)
    {
        //In deze Public heet de counter scoreCounter. Je kunt alle methodes ervan aanroepen.
        counter = scoreCounter;

        smokeReloadTime = 10;
        reloadDelayCount = 0;

    }

    public void act() 
    {
        move(taxiSpeed);
        
        warpUnderground();

        pickupCustomer(passengersInTaxi);

        dropoffPassenger(passengersInTaxi);

        makeSmoke();

        // spawnPolice();

        reloadDelayCount++;

    }  

    public void move(int moveAmt)  
    {  
        // determine direction by keypress checking  
        int dx = 0, dy = 0;  
        if (Greenfoot.isKeyDown("right")){
            setRotation(0);
            dx += 1;  }
        if (Greenfoot.isKeyDown("left")) {
            setRotation(180);
            dx -= 1;  }
        if (Greenfoot.isKeyDown("down")){
            setRotation(90);
            dy += 1;  }
        if (Greenfoot.isKeyDown("up")){
            setRotation(270);
            dy -= 1;  }

        // check for wall on each step of move in both vertical and horizontal directions  
        for (int i = 0; i < moveAmt; i++)  
        {  
            setLocation(getX() + dx, getY());  
            if (getOneIntersectingObject(Wall.class) != null) setLocation(getX() - dx, getY());  
            setLocation(getX(), getY() + dy);  
            if (getOneIntersectingObject(Wall.class) != null) setLocation(getX(), getY() - dy);  
        }  
        
    } 

    {
        if (Greenfoot.isKeyDown("left"))
        {
            move(-1);
        }   

        if (Greenfoot.isKeyDown("right"))
        {
            move(1);
        }

        if (Greenfoot.isKeyDown("up"))
        {
            setLocation(getX(), getY() - 1); 
        }

        if (Greenfoot.isKeyDown("down"))
        {
            setLocation(getX(), getY() + 1); 
        }

    }

    private void makeSmoke(){
        if(Greenfoot.isKeyDown("space"))
        {
            if(reloadDelayCount >= smokeReloadTime)
            {
                if(counter.getValue() >= 500)
                {
                    Greenfoot.playSound("Smoke.au");
                    //maak een rook geluid als je een rookwolk maakt
                    counter.modifyScore(-500);
                    //Haal 500 punten van de score af en maak een rookwolk.
                    getWorld().addObject(new Smoke(), getX(), getY());
                    //maak een nieuwe wolk op de positie waar je staat.
                    reloadDelayCount = 0;
                    //maak een delay om te zorgen dat je om de 10 acts een rookwolk kan maken.
                }

            }
        }
    }
    
    /*
    private void spawnPolice()
    {
        if(spawnTimer >= spawnDelay){
            getWorld().addObject(new Police(), 35, 25);
            spawnTimer = 0;
        }
    }
    */
   
    private void pickupCustomer(int passengersInTaxi)
    {
        if(passengersInTaxi < 4)
        {
            //zolang de hoeveelheid passagiers kleiner is dan 5 (4 max),
            //Mag je de code uitvoeren.
            if(isTouching(Customer.class))
            //Als de taxi de klant aanraakt.
            {
                Greenfoot.playSound("Door.wav");
                //speel het geluid van een autodeur af.
                removeTouching(Customer.class);
                //Verwijder de klant van de wereld.
                this.passengersInTaxi++;
                //Als de klant wordt opgepakt dan wordt de teller van den klant verhoogd
                while(stopTime < 200)
                {
                    taxiSpeed = 0;
                    //om het spannend te maken moet je even wachten voor je weer mag rijden als je een klant ophaalt
                    stopTime--;

                }

                if(taxiSpeed == 0)
                {
                    //De snelheid moet hierna weer 5 zijn om te kunnen rijden.
                    taxiSpeed = 5;
                    Greenfoot.playSound("Thanks.wav");
                    stopTime = 0;
                }

            }
        }
    }

    private void dropoffPassenger(int passengersInTaxi)
    {
        //maak een variabelepunten aan die gelijk is aan het aantal klanten X 200
        int scorePoints = passengersInTaxi * 200;
        if(passengersInTaxi > 0)
        {
            //als de hoeveelheid passengiers groter is dan nul.
            if(isTouching(Destination.class))
            //als de taxi een doel aanraakt
            {
                Greenfoot.playSound("Ticket.wav");
                //speel een geluid af tijdens het wachten
                removeTouching(Destination.class);
                //verwijder de klant en laat de counter scoren.
                counter.modifyScore(scorePoints);
                //Als je de klanten dropt dan moet het aantal passengiers teruggaan naar 0;
                this.passengersInTaxi = 0;

                while(stopTime < 200)
                {
                    taxiSpeed = 0;
                    //om het spannend te maken moet je even wachten voordat je een klant wegbrengt
                    stopTime--;

                } 

                if(taxiSpeed == 0)
                {
                    //De snelheid moet hierna weer 5 zijn om te kunnen rijden.
                    taxiSpeed = 5;
                    Greenfoot.playSound("Money.wav");
                    stopTime = 0;
                }

            }

        }

    }

    public void warpUnderground()
    {
        if(counter.getValue() >= 50)
        {
            //als de score groter is of gelijk is aan 50 dan mag je de methode gebruiken.
            int scorePoints = -50;
            //maak een int aan die -50 punten is.
            
                if(isTouching(undergroundNorth.class) && Greenfoot.isKeyDown("down"))
                {
                    Greenfoot.playSound("Warp.aif");
                    //maak een gekuid voor het teleporteren
                    setLocation(373, 609);
                    //als je de underground aan de west kant aanraakt en rechtbewegen ingedrukt houdt.
                    //Dan ga je naar het station oost.
                    counter.modifyScore(scorePoints);
                    //verlaag na de warp je punten
                }
            
                if(isTouching(undergroundSouth.class) && Greenfoot.isKeyDown("up"))
                {
                    Greenfoot.playSound("Warp.aif");
                    //maak een gekuid voor het teleporteren
                    setLocation(372, 135);
                    //als je de underground aan de west kant aanraakt en rechtbewegen ingedrukt houdt.
                    //Dan ga je naar het station oost.
                    counter.modifyScore(scorePoints);
                    //verlaag na de warp je punten
                }
                
                if(isTouching(undergroundWest.class) && Greenfoot.isKeyDown("right"))
                {
                    Greenfoot.playSound("Warp.aif");
                    //maak een gekuid voor het teleporteren
                    setLocation(608, 369);
                    //als je de underground aan de west kant aanraakt en rechtbewegen ingedrukt houdt.
                    //Dan ga je naar het station oost.
                    counter.modifyScore(scorePoints);
                    //verlaag na de warp je punten
                }
                
                if(isTouching(undergroundEast.class) && Greenfoot.isKeyDown("left"))
                {
                    Greenfoot.playSound("Warp.aif");
                    //maak een gekuid voor het teleporteren
                    setLocation(138, 370);
                    //als je de underground aan de west kant aanraakt en rechtbewegen ingedrukt houdt.
                    //Dan ga je naar het station oost.
                    counter.modifyScore(scorePoints);
                    //verlaag na de warp je punten
                }
            
        }
    
    }
}
